Attribute VB_Name = "mdlWindowProc"
Option Explicit

'*********************************************************************************************
'
' MultiLine ListBox
'
' Subclasing module
'
'*********************************************************************************************
'
' Author: Eduardo Morcillo
' E-Mail: edanmo@geocities.com
' Web Page: http://www.domaindlx.com/e_morcillo
'
' Last Updated: 07/29/1999
'
'*********************************************************************************************

Public Const GWL_WNDPROC = (-4)
Public Const GWL_USERDATA = (-21)

Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (lpvDest As Any, lpvSource As Any, ByVal cbCopy As Long)

Public Function WinProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Dim Ptr As Long, LB As MLListBox

    On Error Resume Next
    
    ' Get object ptr from window
    Ptr = GetWindowLong(hwnd, GWL_USERDATA)
    
    ' Don't set LB to Nothing!
    CopyMemory LB, Ptr, 4
       
    ' Call the control WindowProc
    WinProc = LB.WindowProc(hwnd, uMsg, wParam, lParam)
    
    ' Set MiCtrl = Nothing
    CopyMemory LB, 0&, 4

End Function


